/*
 * myGetObj.cpp
 *
 *  Created on: Jul 1, 2014
 *      Author: nick
 */
#include "myGetObj.h"
#include "myS3Common.h"

using namespace std;

static S3Status myGetObjectDataCallback(int bufferSize, const char *buffer,
                                      void *callbackData)
{
    FILE *outfile = (FILE *) callbackData;

    size_t wrote = fwrite(buffer, 1, bufferSize, outfile);

    return ((wrote < (size_t) bufferSize) ?
            S3StatusAbortedByCallback : S3StatusOK);
}

bool getObject(const string& strBucket, const string& strObj, const string& strPath)
{
	S3GetObjectHandler getObjectHandler =
	{
		{ &MyS3ResponsePropertiesCallback, &MyS3ResponseCompleteCallback },
		&myGetObjectDataCallback
	};

	int64_t ifModifiedSince = -1, ifNotModifiedSince = -1;
	const char *ifMatch = 0, *ifNotMatch = 0;
	uint64_t startByte = 0, byteCount = 0;

	S3GetConditions getConditions =
	{
		ifModifiedSince,
		ifNotModifiedSince,
		ifMatch,
		ifNotMatch
	};

	MyS3Context myS3;
	S3BucketContext ctx;
	if (!myS3.initialize(strBucket.c_str(), ctx))
	{
		return false;
	}
	FILE* outFile = fopen(strPath.c_str(), "w");
	bool bResult = false;
	if (outFile)
	{
		S3_get_object(&ctx, strObj.c_str(), &getConditions, startByte, byteCount, NULL, &getObjectHandler, outFile);

		bResult =  true;

		fclose(outFile);
	}
	return bResult;
}
